#include <iostream.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#define N 18
#define MAXINT 32767

class Sort
{
  private:
     int A[N+1];
     void Initialize(int (*)[], const int);
     void Readjust (int (*)[], unsigned short &);
  public:
     void Tourn ();
     void Vvod();
     void Vyvod();
};

// ------------    ----------

void Sort::Initialize(int (*tree)[], const int size)
// p  p, 
//                .
{
  int j=1, k;

  while (j<=N)
  {  (*tree)[size+j-1] = A[j]; j++;  }
  //   .
  for (j=size+N;j<=2*size-1;j++) (*tree)[j] = - MAXINT;
  //  p p p.
  // p, p   ,
  // p .
  j = size;
  while (j <= 2*size-1)
  {
	 if ( (*tree)[j]>=(*tree)[j+1] )  (*tree)[j / 2] = j;
	 else  (*tree)[j / 2] = j + 1;
	 j += 2;
  }
  //   p.
  k = size / 2;
  while ( k>1 )
  {
	 j = k;
	 while  (j<=2*k-1)
	 {
           if ( (*tree)[(*tree)[j]] >= (*tree)[(*tree)[j+1]] )  (*tree)[j / 2] = (*tree)[j];
           else  (*tree)[j / 2] = (*tree)[j+1];
           j += 2;
	 }
	 k /= 2;
  }
}

void Sort::Readjust (int (*tree)[], unsigned short &i)
// pp p  tree[i].
{
  unsigned short j;

  if  ((i % 2)!=0)  (*tree)[i / 2] = i - 1;
  else  (*tree)[i / 2] = i + 1;
  // p  p.
  i /= 2;
  while  (i>1)
  { //j - p i.
    if  ((i % 2)!=0)  j = i - 1;
    else  j = i + 1;
    if  ((*tree)[(*tree)[i]]>(*tree)[(*tree)[j]])  (*tree)[i / 2] = (*tree)[i];
    else  (*tree)[i / 2] = (*tree)[j];
    i /= 2;
  }
}

void Sort::Tourn ()
{
  const int size = 128; //  ,  
                        //        p p.
                        //  p size 
                        //   2,  N.
  int tree[256];
  int k;
  unsigned short i;

  Initialize(&tree,size);
  // p  ,  p p, p p
  // p , p p,  
  //       x  pp
  // p.
  for(k=N;k>=2;k--)
  {
       i       = tree[1];  // i -    ,
                           //  p.
       A[k]    = tree[i];  //  ,  -
                           // p  p 
                           //  k.
       tree[i] = -MAXINT;
       Readjust (&tree,i);   // pp p
                             //     -
                             // p tree[i].
  }
  A[1] = tree[tree[1]];
}

void Sort::Vvod()
{
	randomize();
	cout <<" :\n";
	for(int i=1;i<=N;i++)
	{  A[i] = random (23);
		cout << A[i] << " ";
	}
	cout << endl;
}

void Sort::Vyvod()
{
	cout <<" pp:\n";
	for (int i=1;i<=N;i++) cout << A[i] << " ";
	cout << endl;
}

void main()
{
   Sort A;
   A.Vvod();
   A.Tourn();
   A.Vyvod();
}
